'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _regenerator = require('babel-runtime/regenerator');

var _regenerator2 = _interopRequireDefault(_regenerator);

exports.default = socketSaga;

var _effects = require('redux-saga/effects');

var _actions = require('./actions');

var _reduxSocket = require('./reduxSocket');

var _reduxSocket2 = _interopRequireDefault(_reduxSocket);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var _marked = [socketSaga].map(_regenerator2.default.mark);

function socketSaga(options) {
    var saga;
    return _regenerator2.default.wrap(function socketSaga$(_context) {
        while (1) {
            switch (_context.prev = _context.next) {
                case 0:
                    saga = new _reduxSocket2.default(options);
                    _context.next = 3;
                    return (0, _effects.takeEvery)(_actions.createOrUpdateChannelAction, saga.createChannel);

                case 3:
                    _context.next = 5;
                    return (0, _effects.takeEvery)(_actions.closeChannelAction, saga.closeChannel);

                case 5:
                case 'end':
                    return _context.stop();
            }
        }
    }, _marked[0], this);
}