'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.createOrUpdateChannelAction = createOrUpdateChannelAction;
exports.closeChannelAction = closeChannelAction;
var createOrUpdate = '@@redux-saga-websocket/CREATE_OR_UPDATE_CHANNEL';
var close = '@@redux-saga-websocket/CLOSE_CHANNEL';

function createOrUpdateChannelAction(uri, data) {
    return {
        type: createOrUpdate,
        payload: {
            uri: uri,
            data: data
        }
    };
}

function closeChannelAction(uri) {
    return {
        type: close,
        payload: {
            uri: uri
        }
    };
}

createOrUpdateChannelAction.toString = function () {
    return createOrUpdate;
};
closeChannelAction.toString = function () {
    return close;
};